#!/usr/bin/env bash
# $1 git url
# $2 artifact path
# $3 save dir
# $4 build name

GitUrl=$1
ArtifactPath=$2
SaveDir=$3
BuildName=$4

RepoDir=$(dirname ${ArtifactPath})
RepoPath="${RepoDir}/repo/${BuildName}"

mkdir -p ${RepoPath}

cd ${RepoPath}

if [ ! -e ${SaveDir} ]
then
    git clone $1 ${SaveDir}

    cd ${SaveDir}
    git config user.name 'autouser'
    git config user.email 'autouser@dnurse.cn'
else
    cd ${SaveDir}
    git reset --hard
    git clean -df
    git pull
fi
