import Vue from 'vue';
import wx from 'weixin-js-sdk';

Vue.prototype.$wechat = wx;

const wechatShare = {
  install(Vue) {
    Vue.prototype.wxShare = function (shareData, callback) {
      this.$axios
        .get('/wechat-sign?url=' + window.location.href.split('#')[0])
        .then((res) => {
          const Data = res.data.detail;
          this.$wechat.config({
            debug: false,
            appId: Data.appId,
            timestamp: Data.timestamp,
            nonceStr: Data.nonceStr,
            signature: Data.signature,
            jsApiList: Data.jsApiList
          });
          this.$wechat.ready(() => {
            // 自定义“分享给朋友”及“分享到QQ”按钮的分享内容（1.4.0）
            this.$wechat.onMenuShareAppMessage({
              title: shareData.title,
              desc: shareData.desc,
              link: shareData.url,
              imgUrl: shareData.image,
              success: () => {
                // 分享成功
                callback();
              },
              cancel: () => {
                console.log('分享取消');
              }
            });
            // 自定义“分享到朋友圈”及“分享到QQ空间”按钮的分享内容（1.4.0）
            this.$wechat.onMenuShareTimeline({
              title: shareData.title,
              link: shareData.url,
              imgUrl: shareData.image,
              success: () => {
                // 分享成功
                callback();
              },
              cancel: () => {
                console.log('分享取消');
              }
            });
            this.$wechat.onMenuShareQQ({
              title: shareData.title,
              desc: shareData.desc,
              link: shareData.url,
              imgUrl: shareData.image,
              success: () => {
                // 分享成功
                callback();
              },
              cancel: () => {
                console.log('分享取消');
              }
            });
            this.$wechat.onMenuShareQZone({
              title: shareData.title,
              desc: shareData.desc,
              link: shareData.url,
              imgUrl: shareData.image,
              success: () => {
                // 分享成功
                callback();
              },
              cancel: () => {
                console.log('分享取消');
              }
            });
            // 自定义“分享到腾讯微博”按钮的分享内容
            this.$wechat.onMenuShareWeibo({
              title: shareData.title,
              desc: shareData.desc,
              link: shareData.url,
              imgUrl: shareData.image,
              success: () => {
                // 分享成功
                callback();
              },
              cancel: () => {
                console.log('分享取消');
              }
            });
          });
          this.$wechat.error((res) => {
            console.log('error:', res);
          });
        });
    };
  }
};

Vue.use(wechatShare);
